import QuickCheck
import Monad
import RedBlack hiding (every)
import System

instance Arbitrary Colour where
  arbitrary = oneof [return R, return B]

instance Arbitrary a => Arbitrary (Tree a) where
  arbitrary = sized t
    where
      t 0 = return E
      t n = oneof [ return E
                  , liftM4 T arbitrary
                             (t (n `div` 2))
                             arbitrary
                             (t (n `div` 2))
                  ]

main = do [n] <- getArgs 
          mapM_ (\i -> check hard prop_insertRB) [1..read n]

hard :: Config
hard = Config
  { maxTest = 1000
  , maxFail = 10000
  , size    = (+ 3) . (`div` 2)
  , every   = \n args -> let s = show n in s ++ [ '\b' | _ <- s ]
  }
